## ioquake3 1.36+u20140116+gdde36d9

=== Makefile ===
#
# ioq3 Makefile
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/x86/)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/x86/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/x86/)
endif

ifndef BUILD_STANDALONE
  BUILD_STANDALONE =
endif
ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     =
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   =
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_MISSIONPACK
  BUILD_MISSIONPACK=
endif
ifndef BUILD_RENDERER_OPENGL2
  BUILD_RENDERER_OPENGL2=
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(COMPILE_ARCH),i86pc)
  COMPILE_ARCH=x86
endif

ifeq ($(COMPILE_ARCH),amd64)
  COMPILE_ARCH=x86_64
endif
ifeq ($(COMPILE_ARCH),x64)
  COMPILE_ARCH=x86_64
endif

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifeq ($(COMPILE_ARCH),axp)
  COMPILE_ARCH=alpha
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=1.36
endif

ifndef CLIENTBIN
CLIENTBIN=ioquake3
endif

ifndef SERVERBIN
SERVERBIN=ioq3ded
endif

ifndef BASEGAME
BASEGAME=baseq3
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=
endif

ifndef MISSIONPACK
MISSIONPACK=missionpack
endif

ifndef MISSIONPACK_CFLAGS
MISSIONPACK_CFLAGS=-DMISSIONPACK
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/quake3"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=1
endif

ifndef USE_CURL_DLOPEN
  ifeq ($(PLATFORM),mingw32)
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=0
endif

ifndef USE_CODEC_OPUS
USE_CODEC_OPUS=1
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_FREETYPE
USE_FREETYPE=0
endif

ifndef USE_INTERNAL_SPEEX
USE_INTERNAL_SPEEX=1
endif

ifndef USE_INTERNAL_OGG
USE_INTERNAL_OGG=1
endif

ifndef USE_INTERNAL_OPUS
USE_INTERNAL_OPUS=1
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=1
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=1
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RCOMMONDIR=$(MOUNT_DIR)/renderercommon
RGL1DIR=$(MOUNT_DIR)/renderergl1
RGL2DIR=$(MOUNT_DIR)/renderergl2
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
Q3UIDIR=$(MOUNT_DIR)/q3_ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
SPEEXDIR=$(MOUNT_DIR)/libspeex
OGGDIR=$(MOUNT_DIR)/libogg-1.3.0
OPUSDIR=$(MOUNT_DIR)/opus-1.0.2
OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.2
ZDIR=$(MOUNT_DIR)/zlib
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
LOKISETUPDIR=misc/setup
NSISDIR=misc/nsis
SDLHDIR=$(MOUNT_DIR)/SDL12
LIBSDIR=$(MOUNT_DIR)/libs

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS=$(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS=$(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS=$(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS=$(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS=$(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
    SDL_LIBS=$(shell pkg-config --silence-errors --libs sdl)
    FREETYPE_CFLAGS=$(shell pkg-config --silence-errors --cflags freetype2)
  endif
  # Use sdl-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl-config),)
      SDL_CFLAGS=$(shell sdl-config --cflags)
      SDL_LIBS=$(shell sdl-config --libs)
    endif
  endif
endif

# Add git version info
USE_GIT=
ifeq ($(wildcard .git),.git)
  GIT_REV=$(shell git show -s --pretty=format:%h-%ad --date=short)
  ifneq ($(GIT_REV),)
    VERSION:=$(VERSION)_GIT_$(GIT_REV)
    USE_GIT=1
  endif
endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
LIB=lib

INSTALL=install
MKDIR=mkdir

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu"))

  ifeq ($(ARCH),x86_64)
    LIB=lib64
  else
  ifeq ($(ARCH),ppc64)
    LIB=lib64
  else
  ifeq ($(ARCH),s390x)
    LIB=lib64
  endif
  endif
  endif

  BASE_CFLAGS = -Wall -fno-strict-aliasing -Wimplicit -Wstrict-prototypes \
    -pipe -DUSE_ICON
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3 -funroll-loops -fomit-frame-pointer
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3 -fomit-frame-pointer -funroll-loops \
      -falign-loops=2 -falign-jumps=2 -falign-functions=2 \
      -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED = true
  else
  ifeq ($(ARCH),x86)
    OPTIMIZEVM = -O3 -march=i586 -fomit-frame-pointer \
      -funroll-loops -falign-loops=2 -falign-jumps=2 \
      -falign-functions=2 -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED=true
  else
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),alpha)
    # According to http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=410555
    # -ffast-math will cause the client to die with SIGFPE on Alpha
    OPTIMIZE = $(OPTIMIZEVM)
  endif
  endif
  endif

  SHLIBEXT=so
  SHLIBCFLAGS=-fPIC -fvisibility=hidden
  SHLIBLDFLAGS=-shared $(LDFLAGS)

  THREAD_LIBS=-lpthread
  LIBS=-ldl -lm

  CLIENT_LIBS=$(SDL_LIBS)
  RENDERER_LIBS = $(SDL_LIBS) -lGL

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += -lopenal
    endif
  endif

  ifeq ($(USE_CURL),1)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += -lcurl
    endif
  endif

  ifeq ($(USE_MUMBLE),1)
    CLIENT_LIBS += -lrt
  endif

  ifeq ($(USE_FREETYPE),1)
    BASE_CFLAGS += $(FREETYPE_CFLAGS)
  endif

  ifeq ($(ARCH),x86)
    # linux32 make ...
    BASE_CFLAGS += -m32
  else
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -m64
  endif
  endif
else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)
  HAVE_VM_COMPILED=true
  LIBS = -framework Cocoa
  CLIENT_LIBS=
  RENDERER_LIBS=
  OPTIMIZEVM=

  BASE_CFLAGS = -Wall -Wimplicit -Wstrict-prototypes

  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -arch ppc -faltivec -mmacosx-version-min=10.2
    OPTIMIZEVM += -O3
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -arch ppc64 -faltivec -mmacosx-version-min=10.2
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM += -march=prescott -mfpmath=sse
    # x86 vm will crash without -mstackrealign since MMX instructions will be
    # used no matter what and they corrupt the frame pointer in VM calls
    BASE_CFLAGS += -arch i386 -m32 -mstackrealign
  endif
  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM += -arch x86_64 -mfpmath=sse
  endif

  # When compiling on OSX for OSX, we're not cross compiling as far as the
  # Makefile is concerned, as target architecture is specified as a compiler
  # argument
  ifeq ($(COMPILE_PLATFORM),darwin)
    CROSS_COMPILING=0
  endif

  ifeq ($(CROSS_COMPILING),1)
    ifeq ($(ARCH),ppc)
      CC=powerpc-apple-darwin10-gcc
      RANLIB=powerpc-apple-darwin10-ranlib
    else
      ifeq ($(ARCH),x86)
        CC=i686-apple-darwin10-gcc
        RANLIB=i686-apple-darwin10-ranlib
      else
        $(error Architecture $(ARCH) is not supported when cross compiling)
      endif
    endif
  else
    TOOLS_CFLAGS += -DMACOS_X
  endif

  BASE_CFLAGS += -fno-strict-aliasing -DMACOS_X -fno-common -pipe

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += -framework OpenAL
    endif
  endif

  ifeq ($(USE_CURL),1)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += -lcurl
    endif
  endif

  ifeq ($(USE_FREETYPE),1)
    BASE_CFLAGS += $(FREETYPE_CFLAGS)
  endif

  BASE_CFLAGS += -D_THREAD_SAFE=1

  ifeq ($(USE_LOCAL_HEADERS),1)
    BASE_CFLAGS += -I$(SDLHDIR)/include
  endif

  # We copy sdlmain before ranlib'ing it so that subversion doesn't think
  #  the file has been modified by each build.
  LIBSDLMAIN=$(B)/libSDLmain.a
  LIBSDLMAINSRC=$(LIBSDIR)/macosx/libSDLmain.a
  CLIENT_LIBS += -framework IOKit \
    $(LIBSDIR)/macosx/libSDL-1.2.0.dylib
  RENDERER_LIBS += -framework OpenGL $(LIBSDIR)/macosx/libSDL-1.2.0.dylib

  OPTIMIZEVM += -falign-loops=16
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  SHLIBEXT=dylib
  SHLIBCFLAGS=-fPIC -fno-common
  SHLIBLDFLAGS=-dynamiclib $(LDFLAGS) -Wl,-U,_com_altivec

  NOTSHLIBCFLAGS=-mdynamic-no-pic

else # ifeq darwin


#############################################################################
# SETUP AND BUILD -- MINGW32
#############################################################################

ifeq ($(PLATFORM),mingw32)

  ifeq ($(CROSS_COMPILING),1)
    # If CC is already set to something generic, we probably want to use
    # something more specific
    ifneq ($(findstring $(strip $(CC)),cc gcc),)
      CC=
    endif

    # We need to figure out the correct gcc and windres
    ifeq ($(ARCH),x86_64)
      MINGW_PREFIXES=amd64-mingw32msvc x86_64-w64-mingw32
    endif
    ifeq ($(ARCH),x86)
      MINGW_PREFIXES=i586-mingw32msvc i686-w64-mingw32
    endif

    ifndef CC
      CC=$(strip $(foreach MINGW_PREFIX, $(MINGW_PREFIXES), \
         $(call bin_path, $(MINGW_PREFIX)-gcc)))
    endif

    ifndef WINDRES
      WINDRES=$(strip $(foreach MINGW_PREFIX, $(MINGW_PREFIXES), \
         $(call bin_path, $(MINGW_PREFIX)-windres)))
    endif
  else
    # Some MinGW installations define CC to cc, but don't actually provide cc,
    # so check that CC points to a real binary and use gcc if it doesn't
    ifeq ($(call bin_path, $(CC)),)
      CC=gcc
    endif

    ifndef WINDRES
      WINDRES=windres
    endif
  endif

=== misc/nsis/Makefile ===
ifndef VERSION
VERSION=1.36_SVN
endif
ifndef RELEASE
RELEASE=0
endif
ifndef ARCH
ARCH=x86
endif
ifndef INSTALLDIR
INSTALLDIR=.
endif
ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif
ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif
ifndef USE_CURL_DLOPEN
USE_CURL_DLOPEN=0
endif
ifndef USE_INTERNAL_SPEEX
USE_INTERNAL_SPEEX=1
endif
ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif
ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=1
endif

SDLDLL=SDL.dll

DEFINES=
ifeq ($(USE_RENDERER_DLOPEN),1)
	DEFINES+= -DUSE_RENDERER_DLOPEN
endif
ifeq ($(USE_OPENAL_DLOPEN),1)
	DEFINES+= -DUSE_OPENAL_DLOPEN
endif
ifeq ($(USE_CURL_DLOPEN),1)
	DEFINES+= -DUSE_CURL_DLOPEN
endif
ifeq ($(USE_INTERNAL_SPEEX),1)
	DEFINES+= -DUSE_INTERNAL_SPEEX
endif
ifeq ($(USE_INTERNAL_ZLIB),1)
	DEFINES+= -DUSE_INTERNAL_ZLIB
endif
ifeq ($(USE_INTERNAL_JPEG),1)
	DEFINES+= -DUSE_INTERNAL_JPEG
endif


all: ioquake3-$(VERSION)-$(RELEASE).$(ARCH).exe

ioquake3.$(ARCH).nsi: ioquake3.nsi.in
	sed 's/XXXVERSIONXXX/$(VERSION)/;s/XXXRELEASEXXX/$(RELEASE)/;s/x86/$(ARCH)/g;s/SDL.dll/$(SDLDLL)/' < $< > $@

ioquake3-$(VERSION)-$(RELEASE).$(ARCH).exe: ioquake3.$(ARCH).nsi
	makensis $(DEFINES) ioquake3.$(ARCH).nsi

clean:
	rm -rf *.exe ioquake3.$(ARCH).nsi

install:
	mkdir -p $(INSTALLDIR)
	mv ioquake3-$(VERSION)-$(RELEASE).$(ARCH).exe $(INSTALLDIR)

.PHONY: all clean

=== debian/control ===
Source: ioquake3
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bruno "Fuddl" Kleinert <fuddl@debian.org>,
           Simon McVittie <smcv@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               libcurl4-gnutls-dev,
               libjpeg8-dev,
               libopenal-dev,
               libopus-dev,
               libopusfile-dev,
               libsdl1.2-dev,
               libspeexdsp-dev,
               libvorbis-dev,
               lsb-release
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-games/ioquake3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ioquake3.git
Homepage: http://www.ioquake3.org/

Package: ioquake3
Architecture: linux-any kfreebsd-any hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: x11-utils | zenity | kdebase-bin
Breaks: openarena (<< 0.8.8-9~)
Description: Game engine for 3D first person shooter games
 This package installs a modified version of the ioQuake3 game engine,
 which can be used to play various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 .
 This package alone isn't of any use; to get a playable game, install
 openarena or another suitable set of game data.

Package: ioquake3-server
Architecture: linux-any kfreebsd-any hurd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: openarena-server (<< 0.8.8-9~)
Description: Standalone server for ioQuake3 based games
 This package installs a modified version of the ioQuake3 dedicated server,
 which can be used to serve various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 .
 This package alone isn't of any use; to get a usable server, install
 openarena-server or another suitable set of server data.

Package: ioquake3-dbg
Architecture: linux-any kfreebsd-any hurd-any
Section: debug
Priority: extra
Depends: ioquake3 (= ${binary:Version}) | ioquake3-server (= ${binary:Version}),
         ${misc:Depends}
Description: debug symbols for the ioquake3 game engine
 This package contains debug symbols for the ioQuake3 game engine,
 which can be used to analyze crashes in games that use Debian's shared
 ioquake engine.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

Q3ARCH             := $(shell $(CURDIR)/debian/q3arch arch     HOST)
Q3PLATFORM         := $(shell $(CURDIR)/debian/q3arch platform HOST)
Q3COMPILE_ARCH     := $(shell $(CURDIR)/debian/q3arch arch     BUILD)
Q3COMPILE_PLATFORM := $(shell $(CURDIR)/debian/q3arch platform BUILD)
distro             := $(shell lsb_release -is)

CFLAGS += -fsigned-char -DWITH_OPENARENA $(CPPFLAGS)

%:
	dh $@ --parallel

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
TARGET = release
else
TARGET = debug
endif

override_dh_auto_build:
	dh_auto_build \
		-- \
		BR=build \
		BD=build \
		V=1 \
		USE_CODEC_OPUS=1 \
		USE_CODEC_VORBIS=1 \
		USE_CURL=1 \
		USE_CURL_DLOPEN=0 \
		USE_INTERNAL_JPEG=0 \
		USE_INTERNAL_OGG=0 \
		USE_INTERNAL_OPUS=0 \
		USE_INTERNAL_SPEEX=0 \
		USE_INTERNAL_ZLIB=0 \
		USE_LOCAL_HEADERS=0 \
		USE_OPENAL=1 \
		USE_OPENAL_DLOPEN=0 \
		USE_VOIP=1 \
		ARCH=$(Q3ARCH) \
		PLATFORM=$(Q3PLATFORM) \
		COMPILE_ARCH=$(Q3COMPILE_ARCH) \
		COMPILE_PLATFORM=$(Q3COMPILE_PLATFORM) \
		BUILD_CLIENT_SMP=1 \
		DEFAULT_BASEDIR=/usr/lib/ioquake3 \
		BUILD_GAME_SO=1 \
		BUILD_GAME_QVM=0 \
		VERSION=$(DEB_VERSION)/$(distro) \
		CFLAGS="$(CFLAGS)" \
		$(TARGET)
	install build/ioq3ded.* build/ioq3ded
	install build/ioquake3.* build/ioquake3
	install README.md build/README

override_dh_strip:
	dh_strip --dbg-package=ioquake3-dbg

# ---------------------------------------------------------------------------

ORIG_REPO ?= https://github.com/ioquake/ioq3/
ORIG_REL = 1.36
# Empty if upstream ever get round to tagging a release
ORIG_REV = dde36d9
# Use the date of the ORIG_REV, or 20130426.1 if you snapshot twice in a day,
# or empty if ORIG_REV is
ORIG_DATE = 20140116
# Non-empty for re-repacks (+dfsg2 or something)
ORIG_SUFFIX =

ifeq (${ORIG_REV},)
	# I have no idea what tags are going to look like, because there
	# aren't any yet. For now, assume they'll be like "1.37".
	ORIG_VER := ${ORIG_REL}${ORIG_SUFFIX}
	ORIG_EXPORT := ${ORIG_REL}
else
	# I'd use "+gitsomething", but that sorts earlier than
	# "+svn1788", and "++gitsomething" is really ugly. +u sorts later,
	# and can be justified as short for "upstream".
	# "+g" because "+u20130426.gfffffff" sorts later than
	# "+u20130426.1.gfffffff", whereas "+u20130426+gfffffff"
	# sorts earlier than "+u20130426.1+gfffffff" as desired.
	ORIG_VER := ${ORIG_REL}+u${ORIG_DATE}+g${ORIG_REV}${ORIG_SUFFIX}
	ORIG_EXPORT := ${ORIG_REV}
endif

get-orig-source:
	git clone --bare --branch master ${ORIG_REPO} ioquake3-${ORIG_VER}.git
	GIT_DIR=ioquake3-${ORIG_VER}.git git archive \
		--format=tar \
		--prefix=ioquake3-${ORIG_VER}.orig/ \
		${ORIG_EXPORT} | tar -xvf-
	rm -rf ioquake3-${ORIG_VER}.orig/code/AL
	rm -rf ioquake3-${ORIG_VER}.orig/code/SDL12
	rm -rf ioquake3-${ORIG_VER}.orig/code/tools/lcc
	rm -rf ioquake3-${ORIG_VER}.orig/code/jpeg-8c
	rm -rf ioquake3-${ORIG_VER}.orig/code/libcurl
	rm -rf ioquake3-${ORIG_VER}.orig/code/libogg-*
	rm -rf ioquake3-${ORIG_VER}.orig/code/libs
	rm -rf ioquake3-${ORIG_VER}.orig/code/libspeex
	rm -rf ioquake3-${ORIG_VER}.orig/code/opus-*
	rm -rf ioquake3-${ORIG_VER}.orig/code/opusfile-*
	rm -rf ioquake3-${ORIG_VER}.orig/code/zlib
	tar --xz -cvf ioquake3_${ORIG_VER}.orig.tar.xz ioquake3-${ORIG_VER}.orig
	rm -rf ioquake3-${ORIG_VER}.orig
	rm -rf ioquake3-${ORIG_VER}.git

=== debian/watch ===
version=3
http://ioquake3.org/files/([\d\.]+)/ioquake3-([\d\.]+)\.tar\.bz2

# Note to uploaders: upstream tarballs are not currently DFSG-free. Update and
# use debian/get-orig-source.sh instead.

## ioquake3 1.36+u20140319+gb099255

=== Makefile ===
--- 
+++ 
@@ -240,9 +240,9 @@
 Q3UIDIR=$(MOUNT_DIR)/q3_ui
 JPDIR=$(MOUNT_DIR)/jpeg-8c
 SPEEXDIR=$(MOUNT_DIR)/libspeex
-OGGDIR=$(MOUNT_DIR)/libogg-1.3.0
-OPUSDIR=$(MOUNT_DIR)/opus-1.0.2
-OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.2
+OGGDIR=$(MOUNT_DIR)/libogg-1.3.1
+OPUSDIR=$(MOUNT_DIR)/opus-1.1
+OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.5
 ZDIR=$(MOUNT_DIR)/zlib
 Q3ASMDIR=$(MOUNT_DIR)/tools/asm
 LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
@@ -534,3 +534,4 @@
     endif
   endif
 
+  ifeq ($(CC),)

=== debian/rules ===
--- 
+++ 
@@ -62,10 +62,10 @@
 ORIG_REPO ?= https://github.com/ioquake/ioq3/
 ORIG_REL = 1.36
 # Empty if upstream ever get round to tagging a release
-ORIG_REV = dde36d9
+ORIG_REV = b099255
 # Use the date of the ORIG_REV, or 20130426.1 if you snapshot twice in a day,
 # or empty if ORIG_REV is
-ORIG_DATE = 20140116
+ORIG_DATE = 20140319
 # Non-empty for re-repacks (+dfsg2 or something)
 ORIG_SUFFIX =
 
@@ -95,7 +95,7 @@
 	rm -rf ioquake3-${ORIG_VER}.orig/code/SDL12
 	rm -rf ioquake3-${ORIG_VER}.orig/code/tools/lcc
 	rm -rf ioquake3-${ORIG_VER}.orig/code/jpeg-8c
-	rm -rf ioquake3-${ORIG_VER}.orig/code/libcurl
+	rm -rf ioquake3-${ORIG_VER}.orig/code/libcurl*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libogg-*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libs
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libspeex

## ioquake3 1.36+u20140802+gca9eebb

=== Makefile ===
--- 
+++ 
@@ -187,28 +187,36 @@
 USE_FREETYPE=0
 endif
 
+ifndef USE_INTERNAL_LIBS
+USE_INTERNAL_LIBS=1
+endif
+
 ifndef USE_INTERNAL_SPEEX
-USE_INTERNAL_SPEEX=1
+USE_INTERNAL_SPEEX=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_INTERNAL_OGG
-USE_INTERNAL_OGG=1
+USE_INTERNAL_OGG=$(USE_INTERNAL_LIBS)
+endif
+
+ifndef USE_INTERNAL_VORBIS
+USE_INTERNAL_VORBIS=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_INTERNAL_OPUS
-USE_INTERNAL_OPUS=1
+USE_INTERNAL_OPUS=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_INTERNAL_ZLIB
-USE_INTERNAL_ZLIB=1
+USE_INTERNAL_ZLIB=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_INTERNAL_JPEG
-USE_INTERNAL_JPEG=1
+USE_INTERNAL_JPEG=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_LOCAL_HEADERS
-USE_LOCAL_HEADERS=1
+USE_LOCAL_HEADERS=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_RENDERER_DLOPEN
@@ -241,6 +249,7 @@
 JPDIR=$(MOUNT_DIR)/jpeg-8c
 SPEEXDIR=$(MOUNT_DIR)/libspeex
 OGGDIR=$(MOUNT_DIR)/libogg-1.3.1
+VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.4
 OPUSDIR=$(MOUNT_DIR)/opus-1.1
 OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.5
 ZDIR=$(MOUNT_DIR)/zlib
@@ -261,19 +270,22 @@
   # set PKG_CONFIG_PATH to influence this, e.g.
   # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
   ifneq ($(call bin_path, pkg-config),)
-    CURL_CFLAGS=$(shell pkg-config --silence-errors --cflags libcurl)
-    CURL_LIBS=$(shell pkg-config --silence-errors --libs libcurl)
-    OPENAL_CFLAGS=$(shell pkg-config --silence-errors --cflags openal)
-    OPENAL_LIBS=$(shell pkg-config --silence-errors --libs openal)
-    SDL_CFLAGS=$(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
-    SDL_LIBS=$(shell pkg-config --silence-errors --libs sdl)
-    FREETYPE_CFLAGS=$(shell pkg-config --silence-errors --cflags freetype2)
+    CURL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags libcurl)
+    CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
+    OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
+    OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
+    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
+    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl)
+  else
+    # assume they're in the system default paths (no -I or -L needed)
+    CURL_LIBS ?= -lcurl
+    OPENAL_LIBS ?= -lopenal
   endif
   # Use sdl-config if all else fails
   ifeq ($(SDL_CFLAGS),)
     ifneq ($(call bin_path, sdl-config),)
-      SDL_CFLAGS=$(shell sdl-config --cflags)
-      SDL_LIBS=$(shell sdl-config --libs)
+      SDL_CFLAGS ?= $(shell sdl-config --cflags)
+      SDL_LIBS ?= $(shell sdl-config --libs)
     endif
   endif
 endif
@@ -322,15 +334,13 @@
 
   ifeq ($(ARCH),x86_64)
     OPTIMIZEVM = -O3 -fomit-frame-pointer -funroll-loops \
-      -falign-loops=2 -falign-jumps=2 -falign-functions=2 \
-      -fstrength-reduce
+      -falign-functions=2 -fstrength-reduce
     OPTIMIZE = $(OPTIMIZEVM) -ffast-math
     HAVE_VM_COMPILED = true
   else
   ifeq ($(ARCH),x86)
     OPTIMIZEVM = -O3 -march=i586 -fomit-frame-pointer \
-      -funroll-loops -falign-loops=2 -falign-jumps=2 \
-      -falign-functions=2 -fstrength-reduce
+      -funroll-loops -falign-functions=2 -fstrength-reduce
     OPTIMIZE = $(OPTIMIZEVM) -ffast-math
     HAVE_VM_COMPILED=true
   else
@@ -367,22 +377,19 @@
 
   ifeq ($(USE_OPENAL),1)
     ifneq ($(USE_OPENAL_DLOPEN),1)
-      CLIENT_LIBS += -lopenal
+      CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
     endif
   endif
 
   ifeq ($(USE_CURL),1)
+    CLIENT_CFLAGS += $(CURL_CFLAGS)
     ifneq ($(USE_CURL_DLOPEN),1)
-      CLIENT_LIBS += -lcurl
+      CLIENT_LIBS += $(CURL_LIBS)
     endif
   endif
 
   ifeq ($(USE_MUMBLE),1)
     CLIENT_LIBS += -lrt
-  endif
-
-  ifeq ($(USE_FREETYPE),1)
-    BASE_CFLAGS += $(FREETYPE_CFLAGS)
   endif
 
   ifeq ($(ARCH),x86)
@@ -457,13 +464,10 @@
   endif
 
   ifeq ($(USE_CURL),1)
+    CLIENT_CFLAGS += $(CURL_CFLAGS)
     ifneq ($(USE_CURL_DLOPEN),1)
-      CLIENT_LIBS += -lcurl
-    endif
-  endif
-
-  ifeq ($(USE_FREETYPE),1)
-    BASE_CFLAGS += $(FREETYPE_CFLAGS)
+      CLIENT_LIBS += $(CURL_LIBS)
+    endif
   endif
 
   BASE_CFLAGS += -D_THREAD_SAFE=1
@@ -480,7 +484,6 @@
     $(LIBSDIR)/macosx/libSDL-1.2.0.dylib
   RENDERER_LIBS += -framework OpenGL $(LIBSDIR)/macosx/libSDL-1.2.0.dylib
 
-  OPTIMIZEVM += -falign-loops=16
   OPTIMIZE = $(OPTIMIZEVM) -ffast-math
 
   SHLIBEXT=dylib
@@ -524,14 +527,3 @@
     endif
   else
     # Some MinGW installations define CC to cc, but don't actually provide cc,
-    # so check that CC points to a real binary and use gcc if it doesn't
-    ifeq ($(call bin_path, $(CC)),)
-      CC=gcc
-    endif
-
-    ifndef WINDRES
-      WINDRES=windres
-    endif
-  endif
-
-  ifeq ($(CC),)

=== debian/changelog ===
ioquake3 (1.36+u20140802+gca9eebb-2+deb8u2) jessie-security; urgency=medium

  * Add patch from upstream:
    + Address read buffer overflow in
      MSG_ReadBits (CVE-2017-11721) (Closes: #870725)
    + Check buffer boundary exactly in MSG_WriteBits, instead of
      potentially failing with a few bytes still available

 -- Simon McVittie <smcv@debian.org>  Sat, 12 Aug 2017 10:15:49 -0400

ioquake3 (1.36+u20140802+gca9eebb-2+deb8u1) jessie-security; urgency=high

  * d/gbp.conf: switch branch to debian/jessie
  * d/patches: Add patches from upstream fixing security vulnerabilities
     - refuse to load potentially auto-downloadable .pk3 files as
       ioquake3 renderers, ioquake3 game code, libcurl, or OpenAL drivers
       (mitigation: auto-downloading is off by default, and in Debian
       we do not dlopen libcurl anyway)
     - refuse to load default configuration file names from a .pk3 file
     - protect cl_renderer, cl_curllib, s_aldriver configuration variables so
       game code cannot set them
     - refuse to overwrite files other than *.txt with the dump console
       command
     - refuse to overwrite files other than *.cfg with the writeconfig
       console command
     (Closes: #857699; CVE-2017-6903)

 -- Simon McVittie <smcv@debian.org>  Tue, 14 Mar 2017 22:29:41 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 9),
                dpkg-dev (>= 1.16.1),
                libcurl4-gnutls-dev,
-               libjpeg8-dev,
+               libjpeg-dev,
                libopenal-dev,
                libopus-dev,
                libopusfile-dev,

=== debian/rules ===
--- 
+++ 
@@ -30,11 +30,7 @@
 		USE_CODEC_VORBIS=1 \
 		USE_CURL=1 \
 		USE_CURL_DLOPEN=0 \
-		USE_INTERNAL_JPEG=0 \
-		USE_INTERNAL_OGG=0 \
-		USE_INTERNAL_OPUS=0 \
-		USE_INTERNAL_SPEEX=0 \
-		USE_INTERNAL_ZLIB=0 \
+		USE_INTERNAL_LIBS=0 \
 		USE_LOCAL_HEADERS=0 \
 		USE_OPENAL=1 \
 		USE_OPENAL_DLOPEN=0 \
@@ -62,10 +58,10 @@
 ORIG_REPO ?= https://github.com/ioquake/ioq3/
 ORIG_REL = 1.36
 # Empty if upstream ever get round to tagging a release
-ORIG_REV = b099255
+ORIG_REV = ca9eebb
 # Use the date of the ORIG_REV, or 20130426.1 if you snapshot twice in a day,
 # or empty if ORIG_REV is
-ORIG_DATE = 20140319
+ORIG_DATE = 20140802
 # Non-empty for re-repacks (+dfsg2 or something)
 ORIG_SUFFIX =
 
@@ -99,6 +95,7 @@
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libogg-*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libs
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libspeex
+	rm -rf ioquake3-${ORIG_VER}.orig/code/libvorbis-*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/opus-*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/opusfile-*
 	rm -rf ioquake3-${ORIG_VER}.orig/code/zlib

## ioquake3 1.36+u20150710+dfsg1

=== Makefile ===
--- 
+++ 
@@ -52,10 +52,21 @@
 #############################################################################
 -include Makefile.local
 
+ifeq ($(COMPILE_PLATFORM),cygwin)
+  PLATFORM=mingw32
+endif
+
 ifndef PLATFORM
 PLATFORM=$(COMPILE_PLATFORM)
 endif
 export PLATFORM
+
+ifeq ($(PLATFORM),mingw32)
+  MINGW=1
+endif
+ifeq ($(PLATFORM),mingw64)
+  MINGW=1
+endif
 
 ifeq ($(COMPILE_ARCH),i86pc)
   COMPILE_ARCH=x86
@@ -160,7 +171,7 @@
 endif
 
 ifndef USE_CURL_DLOPEN
-  ifeq ($(PLATFORM),mingw32)
+  ifdef MINGW
     USE_CURL_DLOPEN=0
   else
     USE_CURL_DLOPEN=1
@@ -260,7 +271,7 @@
 Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
 LOKISETUPDIR=misc/setup
 NSISDIR=misc/nsis
-SDLHDIR=$(MOUNT_DIR)/SDL12
+SDLHDIR=$(MOUNT_DIR)/SDL2
 LIBSDIR=$(MOUNT_DIR)/libs
 
 bin_path=$(shell which $(1) 2> /dev/null)
@@ -274,18 +285,19 @@
     CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
     OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
     OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
-    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
-    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl)
+    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl2|sed 's/-Dmain=SDL_main//')
+    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl2)
+    FREETYPE_CFLAGS ?= $(shell pkg-config --silence-errors --cflags freetype2)
   else
     # assume they're in the system default paths (no -I or -L needed)
     CURL_LIBS ?= -lcurl
     OPENAL_LIBS ?= -lopenal
   endif
-  # Use sdl-config if all else fails
+  # Use sdl2-config if all else fails
   ifeq ($(SDL_CFLAGS),)
-    ifneq ($(call bin_path, sdl-config),)
-      SDL_CFLAGS ?= $(shell sdl-config --cflags)
-      SDL_LIBS ?= $(shell sdl-config --libs)
+    ifneq ($(call bin_path, sdl2-config),)
+      SDL_CFLAGS ?= $(shell sdl2-config --cflags)
+      SDL_LIBS ?= $(shell sdl2-config --libs)
     endif
   endif
 endif
@@ -310,8 +322,10 @@
 
 INSTALL=install
 MKDIR=mkdir
-
-ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu"))
+EXTRA_FILES=
+CLIENT_EXTRA_FILES=
+
+ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
 
   ifeq ($(ARCH),x86_64)
     LIB=lib64
@@ -321,6 +335,10 @@
   else
   ifeq ($(ARCH),s390x)
     LIB=lib64
+  else
+  ifeq ($(ARCH),aarch64)
+    LIB=lib64
+  endif
   endif
   endif
   endif
@@ -329,18 +347,16 @@
     -pipe -DUSE_ICON
   CLIENT_CFLAGS += $(SDL_CFLAGS)
 
-  OPTIMIZEVM = -O3 -funroll-loops -fomit-frame-pointer
+  OPTIMIZEVM = -O3
   OPTIMIZE = $(OPTIMIZEVM) -ffast-math
 
   ifeq ($(ARCH),x86_64)
-    OPTIMIZEVM = -O3 -fomit-frame-pointer -funroll-loops \
-      -falign-functions=2 -fstrength-reduce
+    OPTIMIZEVM = -O3
     OPTIMIZE = $(OPTIMIZEVM) -ffast-math
     HAVE_VM_COMPILED = true
   else
   ifeq ($(ARCH),x86)
-    OPTIMIZEVM = -O3 -march=i586 -fomit-frame-pointer \
-      -funroll-loops -falign-functions=2 -fstrength-reduce
+    OPTIMIZEVM = -O3 -march=i586
     OPTIMIZE = $(OPTIMIZEVM) -ffast-math
     HAVE_VM_COMPILED=true
   else
@@ -413,14 +429,15 @@
   RENDERER_LIBS=
   OPTIMIZEVM=
 
-  BASE_CFLAGS = -Wall -Wimplicit -Wstrict-prototypes
+  BASE_CFLAGS = -Wall -Wimplicit -Wstrict-prototypes -mmacosx-version-min=10.5 \
+    -DMAC_OS_X_VERSION_MIN_REQUIRED=1050
 
   ifeq ($(ARCH),ppc)
-    BASE_CFLAGS += -arch ppc -faltivec -mmacosx-version-min=10.2
+    BASE_CFLAGS += -arch ppc -faltivec
     OPTIMIZEVM += -O3
   endif
   ifeq ($(ARCH),ppc64)
-    BASE_CFLAGS += -arch ppc64 -faltivec -mmacosx-version-min=10.2
+    BASE_CFLAGS += -arch ppc64 -faltivec
   endif
   ifeq ($(ARCH),x86)
     OPTIMIZEVM += -march=prescott -mfpmath=sse
@@ -440,13 +457,13 @@
   endif
 
   ifeq ($(CROSS_COMPILING),1)
-    ifeq ($(ARCH),ppc)
-      CC=powerpc-apple-darwin10-gcc
-      RANLIB=powerpc-apple-darwin10-ranlib
+    ifeq ($(ARCH),x86_64)
+      CC=x86_64-apple-darwin13-cc
+      RANLIB=x86_64-apple-darwin13-ranlib
     else
       ifeq ($(ARCH),x86)
-        CC=i686-apple-darwin10-gcc
-        RANLIB=i686-apple-darwin10-ranlib
+        CC=i386-apple-darwin13-cc
+        RANLIB=i386-apple-darwin13-ranlib
       else
         $(error Architecture $(ARCH) is not supported when cross compiling)
       endif
@@ -478,11 +495,12 @@
 
   # We copy sdlmain before ranlib'ing it so that subversion doesn't think
   #  the file has been modified by each build.
-  LIBSDLMAIN=$(B)/libSDLmain.a
-  LIBSDLMAINSRC=$(LIBSDIR)/macosx/libSDLmain.a
+  LIBSDLMAIN=$(B)/libSDL2main.a
+  LIBSDLMAINSRC=$(LIBSDIR)/macosx/libSDL2main.a
   CLIENT_LIBS += -framework IOKit \
-    $(LIBSDIR)/macosx/libSDL-1.2.0.dylib
-  RENDERER_LIBS += -framework OpenGL $(LIBSDIR)/macosx/libSDL-1.2.0.dylib
+    $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib
+  RENDERER_LIBS += -framework OpenGL $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib
+  CLIENT_EXTRA_FILES += $(LIBSDIR)/macosx/libSDL2-2.0.0.dylib
 
   OPTIMIZE = $(OPTIMIZEVM) -ffast-math
 
@@ -499,7 +517,7 @@
 # SETUP AND BUILD -- MINGW32
 #############################################################################
 
-ifeq ($(PLATFORM),mingw32)
+ifdef MINGW
 
   ifeq ($(CROSS_COMPILING),1)
     # If CC is already set to something generic, we probably want to use
@@ -513,7 +531,7 @@
       MINGW_PREFIXES=amd64-mingw32msvc x86_64-w64-mingw32
     endif
     ifeq ($(ARCH),x86)
-      MINGW_PREFIXES=i586-mingw32msvc i686-w64-mingw32
+      MINGW_PREFIXES=i586-mingw32msvc i686-w64-mingw32 i686-pc-mingw32
     endif
 
     ifndef CC
@@ -522,8 +540,3 @@
     endif
 
     ifndef WINDRES
-      WINDRES=$(strip $(foreach MINGW_PREFIX, $(MINGW_PREFIXES), \
-         $(call bin_path, $(MINGW_PREFIX)-windres)))
-    endif
-  else
-    # Some MinGW installations define CC to cc, but don't actually provide cc,

=== debian/control ===
Source: ioquake3
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bruno "Fuddl" Kleinert <fuddl@debian.org>,
           Simon McVittie <smcv@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               libcurl4-gnutls-dev,
               libjpeg-dev,
               libopenal-dev,
               libopus-dev,
               libopusfile-dev,
               libsdl2-dev (>= 2.0.0),
               libspeexdsp-dev,
               libvorbis-dev,
               lsb-release
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-games/ioquake3.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/ioquake3.git
Homepage: http://www.ioquake3.org/

Package: ioquake3
Architecture: linux-any kfreebsd-any hurd-any
Depends:
 ioquake3-server (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: x11-utils | zenity | kdebase-bin
Breaks: openarena (<< 0.8.8-9~)
Description: Game engine for 3D first person shooter games
 This package installs a modified version of the ioQuake3 game engine,
 which can be used to play various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 .
 This package alone isn't of any use; to get a playable game, install
 openarena or another suitable set of game data.

Package: ioquake3-server
Architecture: linux-any kfreebsd-any hurd-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks: openarena-server (<< 0.8.8-9~)
Description: Engine for 3D first person shooter games - server and common files
 This package contains common files for the ioQuake3 game engine,
 which can be used to play various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 It also contains the dedicated server binary.
 .
 This package alone isn't of any use; to get a playable game, install
 openarena or another suitable set of game data, or to get a usable server,
 install openarena-server or another suitable set of server data.

Package: ioquake3-dbg
Architecture: linux-any kfreebsd-any hurd-any
Section: debug
Priority: extra
Depends:
 ioquake3-server (= ${binary:Version}),
 ${misc:Depends},
Description: debug symbols for the ioquake3 game engine
 This package contains debug symbols for the ioQuake3 game engine,
 which can be used to analyze crashes in games that use Debian's shared
 ioquake engine.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,16 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
+
+export LC_ALL=C.UTF-8
+export TZ=UTC
+
+DEB_CPPFLAGS_MAINT_APPEND := \
+	-DWITH_OPENARENA \
+	$(NULL)
+
+DEB_CFLAGS_MAINT_APPEND := \
+	-fsigned-char \
+	$(NULL)
 
 include /usr/share/dpkg/default.mk
 
@@ -8,8 +19,7 @@
 Q3COMPILE_ARCH     := $(shell $(CURDIR)/debian/q3arch arch     BUILD)
 Q3COMPILE_PLATFORM := $(shell $(CURDIR)/debian/q3arch platform BUILD)
 distro             := $(shell lsb_release -is)
-
-CFLAGS += -fsigned-char -DWITH_OPENARENA $(CPPFLAGS)
+PRODUCT_DATE := $(shell date --utc --date="`dpkg-parsechangelog -SDate`" "+%b %_d %Y")
 
 %:
 	dh $@ --parallel
@@ -20,9 +30,7 @@
 TARGET = debug
 endif
 
-override_dh_auto_build:
-	dh_auto_build \
-		-- \
+OPTIONS := \
 		BR=build \
 		BD=build \
 		V=1 \
@@ -44,11 +52,29 @@
 		BUILD_GAME_SO=1 \
 		BUILD_GAME_QVM=0 \
 		VERSION=$(DEB_VERSION)/$(distro) \
-		CFLAGS="$(CFLAGS)" \
-		$(TARGET)
-	install build/ioq3ded.* build/ioq3ded
-	install build/ioquake3.* build/ioquake3
-	install README.md build/README
+		PRODUCT_DATE='$(PRODUCT_DATE)' \
+		CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
+		NO_STRIP=1 \
+		$(NULL)
+
+override_dh_auto_build:
+	dh_auto_build -- $(OPTIONS) $(TARGET)
+
+override_dh_auto_install: DESTDIR = debian/tmp
+override_dh_auto_install:
+	install -d $(DESTDIR)/usr/lib/ioquake3/baseq3/
+	$(MAKE) copyfiles $(OPTIONS) COPYDIR=$(DESTDIR)/usr/lib/ioquake3
+	mv $(DESTDIR)/usr/lib/ioquake3/ioquake3.* $(DESTDIR)/usr/lib/ioquake3/ioquake3
+	mv $(DESTDIR)/usr/lib/ioquake3/ioq3ded.* $(DESTDIR)/usr/lib/ioquake3/ioq3ded
+	install -m644 README.md build/README
+	install -d $(DESTDIR)/usr/lib/quake3/base/baseq3/
+	install -d $(DESTDIR)/usr/lib/quake3/demo/demoq3/
+	install -d $(DESTDIR)/usr/lib/quake3/ta/baseq3/
+	install -d $(DESTDIR)/usr/lib/quake3/ta/missionpack/
+	cd $(DESTDIR)/usr/lib/quake3/base/baseq3 && ln -s ../../../ioquake3/baseq3/*.so .
+	cd $(DESTDIR)/usr/lib/quake3/demo/demoq3 && ln -s ../../../ioquake3/baseq3/*.so .
+	cd $(DESTDIR)/usr/lib/quake3/ta/baseq3 && ln -s ../../../ioquake3/baseq3/*.so .
+	cd $(DESTDIR)/usr/lib/quake3/ta/missionpack && ln -s ../../../ioquake3/missionpack/*.so .
 
 override_dh_strip:
 	dh_strip --dbg-package=ioquake3-dbg
@@ -57,13 +83,12 @@
 
 ORIG_REPO ?= https://github.com/ioquake/ioq3/
 ORIG_REL = 1.36
-# Empty if upstream ever get round to tagging a release
-ORIG_REV = ca9eebb
+# Empty if packaging a tagged release
+ORIG_REV = 1bb2bc370d250101baf048a6edd1cc349aa996e9
 # Use the date of the ORIG_REV, or 20130426.1 if you snapshot twice in a day,
 # or empty if ORIG_REV is
-ORIG_DATE = 20140802
-# Non-empty for re-repacks (+dfsg2 or something)
-ORIG_SUFFIX =
+ORIG_DATE = 20150710
+ORIG_SUFFIX = +dfsg1
 
 ifeq (${ORIG_REV},)
 	# I have no idea what tags are going to look like, because there
@@ -74,10 +99,7 @@
 	# I'd use "+gitsomething", but that sorts earlier than
 	# "+svn1788", and "++gitsomething" is really ugly. +u sorts later,
 	# and can be justified as short for "upstream".
-	# "+g" because "+u20130426.gfffffff" sorts later than
-	# "+u20130426.1.gfffffff", whereas "+u20130426+gfffffff"
-	# sorts earlier than "+u20130426.1+gfffffff" as desired.
-	ORIG_VER := ${ORIG_REL}+u${ORIG_DATE}+g${ORIG_REV}${ORIG_SUFFIX}
+	ORIG_VER := ${ORIG_REL}+u${ORIG_DATE}${ORIG_SUFFIX}
 	ORIG_EXPORT := ${ORIG_REV}
 endif
 
@@ -89,6 +111,7 @@
 		${ORIG_EXPORT} | tar -xvf-
 	rm -rf ioquake3-${ORIG_VER}.orig/code/AL
 	rm -rf ioquake3-${ORIG_VER}.orig/code/SDL12
+	rm -rf ioquake3-${ORIG_VER}.orig/code/SDL2
 	rm -rf ioquake3-${ORIG_VER}.orig/code/tools/lcc
 	rm -rf ioquake3-${ORIG_VER}.orig/code/jpeg-8c
 	rm -rf ioquake3-${ORIG_VER}.orig/code/libcurl*

## ioquake3 1.36+u20160122+dfsg1

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')
 
-COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/x86/)
+COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/x86/ | sed -e 's/^arm.*/arm/')
 
 ifeq ($(COMPILE_PLATFORM),sunos)
   # Solaris uname and GNU uname differ
@@ -200,10 +200,6 @@
 
 ifndef USE_INTERNAL_LIBS
 USE_INTERNAL_LIBS=1
-endif
-
-ifndef USE_INTERNAL_SPEEX
-USE_INTERNAL_SPEEX=$(USE_INTERNAL_LIBS)
 endif
 
 ifndef USE_INTERNAL_OGG
@@ -258,7 +254,6 @@
 UIDIR=$(MOUNT_DIR)/ui
 Q3UIDIR=$(MOUNT_DIR)/q3_ui
 JPDIR=$(MOUNT_DIR)/jpeg-8c
-SPEEXDIR=$(MOUNT_DIR)/libspeex
 OGGDIR=$(MOUNT_DIR)/libogg-1.3.1
 VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.4
 OPUSDIR=$(MOUNT_DIR)/opus-1.1
@@ -317,34 +312,18 @@
 # SETUP AND BUILD -- LINUX
 #############################################################################
 
-## Defaults
-LIB=lib
-
 INSTALL=install
 MKDIR=mkdir
 EXTRA_FILES=
 CLIENT_EXTRA_FILES=
 
+ifneq (,$(findstring "$(COMPILE_PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
+  TOOLS_CFLAGS += -DARCH_STRING=\"$(COMPILE_ARCH)\"
+endif
+
 ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
-
-  ifeq ($(ARCH),x86_64)
-    LIB=lib64
-  else
-  ifeq ($(ARCH),ppc64)
-    LIB=lib64
-  else
-  ifeq ($(ARCH),s390x)
-    LIB=lib64
-  else
-  ifeq ($(ARCH),aarch64)
-    LIB=lib64
-  endif
-  endif
-  endif
-  endif
-
   BASE_CFLAGS = -Wall -fno-strict-aliasing -Wimplicit -Wstrict-prototypes \
-    -pipe -DUSE_ICON
+    -pipe -DUSE_ICON -DARCH_STRING=\\\"$(ARCH)\\\"
   CLIENT_CFLAGS += $(SDL_CFLAGS)
 
   OPTIMIZEVM = -O3
@@ -540,3 +519,7 @@
     endif
 
     ifndef WINDRES
+      WINDRES=$(strip $(foreach MINGW_PREFIX, $(MINGW_PREFIXES), \
+         $(call bin_path, $(MINGW_PREFIX)-windres)))
+    endif
+  else

=== debian/control ===
Source: ioquake3
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Bruno "Fuddl" Kleinert <fuddl@debian.org>,
 Simon McVittie <smcv@debian.org>,
Build-Depends:
 debhelper (>= 9),
 dpkg-dev (>= 1.16.1),
 libcurl4-gnutls-dev,
 libjpeg-dev,
 libopenal-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev (>= 2.0.0),
 libvorbis-dev,
Standards-Version: 3.9.6
Vcs-Git: https://anonscm.debian.org/git/pkg-games/ioquake3.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/ioquake3.git
Homepage: http://www.ioquake3.org/

Package: ioquake3
Architecture: any
Depends:
 ioquake3-server (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 x11-utils | zenity | kdebase-bin,
Breaks:
 openarena (<< 0.8.8-9~),
Description: Game engine for 3D first person shooter games
 This package installs a modified version of the ioQuake3 game engine,
 which can be used to play various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 .
 This package alone isn't of any use; to get a playable game, install
 openarena or another suitable set of game data.

Package: ioquake3-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
 ioquake3-server (= ${binary:Version}),
 ${misc:Depends},
Description: debug symbols for the ioquake3 game engine
 This package contains debug symbols for the ioQuake3 game engine,
 which can be used to analyze crashes in games that use Debian's shared
 ioquake engine.

Package: ioquake3-server
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 openarena-server (<< 0.8.8-9~),
Description: Engine for 3D first person shooter games - server and common files
 This package contains common files for the ioQuake3 game engine,
 which can be used to play various games based on that engine, such as
 OpenArena, Quake III: Arena, World of Padman and Urban Terror.
 It also contains the dedicated server binary.
 .
 This package alone isn't of any use; to get a playable game, install
 openarena or another suitable set of game data, or to get a usable server,
 install openarena-server or another suitable set of server data.

=== debian/rules ===
--- 
+++ 
@@ -14,11 +14,6 @@
 
 include /usr/share/dpkg/default.mk
 
-Q3ARCH             := $(shell $(CURDIR)/debian/q3arch arch     HOST)
-Q3PLATFORM         := $(shell $(CURDIR)/debian/q3arch platform HOST)
-Q3COMPILE_ARCH     := $(shell $(CURDIR)/debian/q3arch arch     BUILD)
-Q3COMPILE_PLATFORM := $(shell $(CURDIR)/debian/q3arch platform BUILD)
-distro             := $(shell lsb_release -is)
 PRODUCT_DATE := $(shell date --utc --date="`dpkg-parsechangelog -SDate`" "+%b %_d %Y")
 
 %:
@@ -43,17 +38,15 @@
 		USE_OPENAL=1 \
 		USE_OPENAL_DLOPEN=0 \
 		USE_VOIP=1 \
-		ARCH=$(Q3ARCH) \
-		PLATFORM=$(Q3PLATFORM) \
-		COMPILE_ARCH=$(Q3COMPILE_ARCH) \
-		COMPILE_PLATFORM=$(Q3COMPILE_PLATFORM) \
+		$(shell $(CURDIR)/debian/q3arch make ${DEB_HOST_GNU_CPU} ${DEB_HOST_GNU_SYSTEM}) \
 		BUILD_CLIENT_SMP=1 \
 		DEFAULT_BASEDIR=/usr/lib/ioquake3 \
 		BUILD_GAME_SO=1 \
 		BUILD_GAME_QVM=0 \
-		VERSION=$(DEB_VERSION)/$(distro) \
+		VERSION=$(DEB_VERSION)/$(DEB_VENDOR) \
 		PRODUCT_DATE='$(PRODUCT_DATE)' \
 		CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
+		FULLBINEXT="" \
 		NO_STRIP=1 \
 		$(NULL)
 
@@ -64,8 +57,6 @@
 override_dh_auto_install:
 	install -d $(DESTDIR)/usr/lib/ioquake3/baseq3/
 	$(MAKE) copyfiles $(OPTIONS) COPYDIR=$(DESTDIR)/usr/lib/ioquake3
-	mv $(DESTDIR)/usr/lib/ioquake3/ioquake3.* $(DESTDIR)/usr/lib/ioquake3/ioquake3
-	mv $(DESTDIR)/usr/lib/ioquake3/ioq3ded.* $(DESTDIR)/usr/lib/ioquake3/ioq3ded
 	install -m644 README.md build/README
 	install -d $(DESTDIR)/usr/lib/quake3/base/baseq3/
 	install -d $(DESTDIR)/usr/lib/quake3/demo/demoq3/
@@ -84,10 +75,10 @@
 ORIG_REPO ?= https://github.com/ioquake/ioq3/
 ORIG_REL = 1.36
 # Empty if packaging a tagged release
-ORIG_REV = 1bb2bc370d250101baf048a6edd1cc349aa996e9
+ORIG_REV = 558da2527725fff521bbd3a6d341c606d395d92a
 # Use the date of the ORIG_REV, or 20130426.1 if you snapshot twice in a day,
 # or empty if ORIG_REV is
-ORIG_DATE = 20150710
+ORIG_DATE = 20160122
 ORIG_SUFFIX = +dfsg1
 
 ifeq (${ORIG_REV},)
@@ -125,3 +116,9 @@
 	tar --xz -cvf ioquake3_${ORIG_VER}.orig.tar.xz ioquake3-${ORIG_VER}.orig
 	rm -rf ioquake3-${ORIG_VER}.orig
 	rm -rf ioquake3-${ORIG_VER}.git
+
+# to be invoked from a git checkout with upstream github as a remote;
+# tarball ends up in ../build-area
+maintainer-get-orig-source:
+	$(MAKE) -f debian/rules get-orig-source ORIG_REPO=$$(pwd)/.git
+	mv -i -v ioquake3_${ORIG_VER}.orig.tar.xz ../build-area/

=== debian/watch ===
--- 
+++ 
@@ -1,4 +1,5 @@
 version=3
+opts=dversionmangle=s/(\+u[0-9]+\+g[a-f0-9]+)?\+(dfsg|ds)[0-9]+$// \
 http://ioquake3.org/files/([\d\.]+)/ioquake3-([\d\.]+)\.tar\.bz2
 
 # Note to uploaders: upstream tarballs are not currently DFSG-free. Update and
